rvsel<-function(x,y,cx=NULL,family=c("gaussian","binomial"),weight=NULL,adapted=TRUE,ad.alpha=0.1) {
   family=match.arg(family)
   x<-as.matrix(x)
   n<-as.integer(nrow(x))
   p<-as.integer(ncol(x))
   if (p<2) stop("Data must have more than one variant for variable selection")
   ka=as.integer(1)
   if (is.null(dim(cx))) nc=as.integer(1)
   else nc=as.integer(ncol(cx))
   cx=as.matrix(cx)
   lq=as.integer(2^p-1)
   if (is.null(weight)) wts=as.double(rep(1,p))
   else wts=as.double(weight)
   jerr=as.integer(0)
   re=rep(0,p)
   re[1]<-1
   if (!is.null(cx)) {
   if (family=="gaussian") ry<-lm(y~cx)$residuals
   if (family=="binomial") ry<-residuals(glm(y~cx,family=family),"response")
   }
   else ry<-y
   if (adapted) {
      x[x!=0]<-1
      coef<-apply(x,2,function(w) summary(lm(y~w))$coef[2,1])
      pval<-apply(x,2,function(w) summary(lm(y~w))$coef[2,4])
      sgn<-sign(as.numeric(coef))
      ww<-which(pval<=ad.alpha)
      if (length(ww)>0) {
          wp<-which(sgn[ww]<0)
          if (length(wp)>0) x[1:n,ww[wp]]<-1-x[1:n,ww[wp]]
      }
   }
   y=as.double(scale(ry))
   zs=as.double(0)
   h<-.Fortran("maxcorr",n,p,as.double(x),y,re=as.double(re),lq,wts,zs=zs,
   out=as.double(re),jerr=jerr)
   jerr<-h$jerr
   if (h$jerr==0) selection=as.vector(h$out)
   else selection=rep(0,p)
   if (is.null(colnames(x))) names(selection) <- paste("Var",1:p,sep="")
   else names(selection)<-colnames(x)
   weight=wts
return(list(selection=cbind(selection,weight),score=h$zs,jerr=h$jerr))
}
